/*
	main.c

	code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include "vramdisk.h"

/* ꥢ */
LOCAL	DrvWork	WorkArea;

/* ѥ᡼Ф */
LOCAL	WERR	getParm(TC *arg)
{
	/* ҤƤͤѥ᡼Ȥ */
	for (; *arg != TNULL; arg++) {
		if (*arg < TK_0 || *arg > TK_9) continue;

		return tc_strtol(arg, &arg, 0) * 1024;
	}

	return ER_PAR;
}

/* ɥ饤Сȥݥ */
EXPORT	ERR	main(Bool start, TC *arg)
{
	ERR	err;
	W	fbsize, usedsize, reqsize;
	VP	fbaddr;

	/* λ */
	if (!start) {
		goto fin1;
	}

	/* ꥢν */
	memset(&WorkArea, 0, sizeof(DrvWork));

	/* ѥåХåեID */
	err = get_mbfid();
	if (err < ER_OK) {
		D(("main: get_mbfid %d\n", err));
		goto fin0;
	}
	WorkArea.mbfid = err;

	/* ѲǽVideo-RAMΰ˴ؤ */
	err = getinfo_fb(&fbaddr, &fbsize, &usedsize);
	if (err < ER_OK) {
		D(("main: getinfo_fb %d\n", err));
		goto fin0;
	}

	D(("main: fbaddr %#x fbsize %#x usedsize %#x\n",
	   fbaddr, fbsize, usedsize));

	/* ѲǽVideo-RAMΰ褬̵Ͻλ */
	if (fbaddr == NULL || fbsize <= usedsize) {
		D(("main: not enough VRAM\n"));
		err = ER_NOMEM;
		goto fin0;
	}

	/* Video-RAM˴ؤ¸ */
	WorkArea.memadr  = fbaddr + usedsize;
	WorkArea.memsize = fbsize - usedsize;

	/* Υå */
	reqsize = getParm(arg);

	/* ͭʰξ硢Video-RAM˴ؤ */
	if (reqsize > 0 && reqsize < WorkArea.memsize) {
		WorkArea.memadr += WorkArea.memsize - reqsize;	/*  */
		WorkArea.memsize = reqsize;
	}

	/* εư */
	err = vrd_start(&WorkArea);
	if (err < ER_OK) {
		D(("main: vrd_start %d\n", err));
		goto fin0;
	}

	/* εưλ */
	err = ER_OK;
	goto fin0;

 fin1:
	err = vrd_finish(&WorkArea);
 fin0:
	return err;
}
