/*
	vramdisk.c

	code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include "vramdisk.h"

LOCAL	TC	DrvName[] = {TK_v, TK_r, TK_d, TK_a, TK_NULL};

/* ɤ߽ */
LOCAL	ERR	readwrite_sect(DrvWork *wk, DevReq *q, DevRsp *r)
{
	ERR	err;
	W	alen;

	/* datacnt == 0ʤ񤭹߲ǽʥ֥å֤ */
	if (!q->datacnt) {
		alen = wk->diskinfo.blockcont;
		err = ER_OK;
		goto fin0;
	}

	/* datano/datacnt */
	if ((q->datano + q->datacnt) > wk->diskinfo.blockcont) {
		alen = 0;
		err = ER_PAR;
		goto fin0;
	}

	/* ե졼Хåեᥤ֤Υǡž */
	if (q->cmd.cmd == DC_READ) {
		if (q->memptr != NULL) {
			memcpy(q->memptr,
			       wk->mapadr + SECTORtoBYTE(q->datano),
			       SECTORtoBYTE(q->datacnt));
		}
	} else {
		if (q->memptr != NULL) {
			memcpy(wk->mapadr + SECTORtoBYTE(q->datano),
			       q->memptr,
			       SECTORtoBYTE(q->datacnt));
		} else {
			memset(wk->mapadr + SECTORtoBYTE(q->datano),
			       0,
			       SECTORtoBYTE(q->datacnt));
		}
	}

	/* ǡɤ߽񤭤Ǥ */
	alen = q->datacnt;
	err = ER_OK;
 fin0:
	r->datacnt = alen;

	return err;
}

/* DN_DISKEVENT(w) */
LOCAL	ERR	write_dn_diskevent(DrvWork *wk, DevReq *q, DevRsp *r)
{
#define	ArgLen	sizeof(ID)

	ERR	err;

	/* ٤񤭹Ǥʤ */
	if (q->datacnt < ArgLen) {
		err = ER_PAR;
		goto fin0;
	}

	/* ΤоݤȤʤåХåե */
	memcpy(&wk->mbfid, q->memptr, ArgLen);
	r->datacnt = ArgLen;

	err = ER_OK;
 fin0:
	return err;
}

/* DN_DISKFORMAT(w) */
LOCAL	ERR	write_dn_diskformat(DrvWork *wk, DevReq *q, DevRsp *r)
{
	ERR	err;
	DiskFormat	fmt;

	/* 񤭹ߤػߤƤ */
	if (wk->diskinfo.protect) {
		err = ER_RONLY;
		goto fin0;
	}

	/* ٤񤭹Ǥʤ */
	if (q->datacnt < sizeof(fmt)) {
		err = ER_PAR;
		goto fin0;
	}

	/* եޥåȷ(DiskFormat)Υå */
	memcpy(&fmt, q->memptr, sizeof(fmt));
	if (fmt != wk->diskinfo.format) {
		return ER_PAR;
		goto fin0;
	}

	/* Ŭʥǡ뤿ν */
	q->cmd.cmd = DC_WRITE;
	q->datano  = 0;
	q->datacnt = wk->diskinfo.blockcont;
	q->memptr  = NULL;

	/* Ƥν */
	err = readwrite_sect(wk, q, r);
	if (err < ER_OK) {
		D(("write_dn_diskformat: readwrite_sect %d\n", err));
	}

	/* 񤭹ϥǤʤDiskFormatΥ(byte) */
	r->datacnt = sizeof(DiskFormat);

 fin0:
	return err;
}

/* DN_DISKINIT(w) */
LOCAL	ERR	write_dn_diskinit(DrvWork *wk, DevReq *q, DevRsp *r)
{
	/* ⤷ʤ */
	r->datacnt = sizeof(DiskInit);

	return ER_OK;
}	

/* write׵ */
LOCAL	ERR	vrd_write(DrvWork *wk, DevReq *q, DevRsp *r)
{
	if (q->datacnt < 0) return ER_PAR;
	if (q->datano >= 0) return readwrite_sect(wk, q, r);

	switch (q->datano) {
	case	DN_DISKEVENT:	return write_dn_diskevent(wk, q, r);
	case	DN_DISKFORMAT:	return write_dn_diskformat(wk, q, r);
	case	DN_DISKINIT:	return write_dn_diskinit(wk, q, r);
	case	DN_DISKCMD:	return ER_NOSPT;
	default:		return ER_PAR;
	}
}

/* DN_DISKEVENT(r) */
LOCAL	ERR	read_dn_diskevent(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	len;

	len = (q->datacnt < sizeof(ID)) ? q->datacnt : sizeof(ID);

	memcpy(q->memptr, &wk->mbfid, len);

	r->datacnt = len;

	return ER_OK;
}

/* DN_DISKINFO(r) */
LOCAL	ERR	read_dn_diskinfo(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	len;

	len = (q->datacnt < sizeof(DiskInfo)) ? q->datacnt : sizeof(DiskInfo);

	memcpy(q->memptr, &wk->diskinfo, len);

	r->datacnt = len;

	return ER_OK;
}

/* DN_DISKMEMADR(r) */
LOCAL	ERR	read_dn_diskmemadr(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	len;

	len = (q->datacnt < sizeof(VP)) ? q->datacnt : sizeof(VP);

	memcpy(q->memptr, &wk->mapadr, len);

	r->datacnt = len;

	return ER_OK;
}

/* DN_DISKCHSINFO(r) */
LOCAL	ERR	read_dn_diskchsinfo(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	len;
	DiskCHSInfo	dc;

	len = (q->datacnt < sizeof(dc)) ? q->datacnt : sizeof(dc);

	dc.cylinder = 1;
	dc.head     = 1;
	dc.sector   = wk->diskinfo.blockcont;

	memcpy(q->memptr, &dc, len);

	r->datacnt = len;

	return ER_OK;
}

/* read׵ */
LOCAL	ERR	vrd_read(DrvWork *wk, DevReq *q, DevRsp *r)
{
	if (q->datacnt < 0) return ER_PAR;
	if (q->datano >= 0) return readwrite_sect(wk, q, r);

	switch (q->datano) {
	case	DN_DISKEVENT:		return read_dn_diskevent(wk, q, r);
	case	DN_DISKINFO:		return read_dn_diskinfo(wk, q, r);
	case	DN_DISKMEMADR:		return read_dn_diskmemadr(wk, q, r);
	case	DN_DISKPARTINFO:	return ER_PAR;
	case	DN_DISKCHSINFO:		return read_dn_diskchsinfo(wk, q, r);
	case	DN_DISKIDINFO:		return ER_NOSPT;
	default:			return ER_PAR;
	}
}

/* Ƽ׵Ф */
LOCAL	ERR	vrd_request(DrvWork *wk, DevReq *q, DevRsp *r)
{
	switch (q->cmd.cmd) {
		/* ̾׵ */
	case	DC_OPEN:
	case	DC_CLOSE:
	case	DC_CLOSEALL:	return ER_OK;		/* ä˲⤷ʤ */

	case	DC_READ:	return vrd_read(wk, q, r);
	case	DC_WRITE:	return vrd_write(wk, q, r);

		/* ü׵ */
	case	DC_ABORT:
	case	DC_SUSPEND:
	case	DC_RESUME:	return ER_OK;		/* ä˲⤷ʤ */

		/* ¾ */
	default:		return ER_NOSPT;	/* ݡϰϳ */
	}
}

/* ɥ쥹֤ȥå */
LOCAL	ERR	taskspace_switch(DevReq *q)
{
	ERR	err;
	W	mul;

	/* פξ */
	if (!q->cmd.adcnv || q->datacnt <= 0) {
		return ER_OK;
	}

	/* ɥ쥹֤ */
	err = SetTaskSpace(q->taskid);
	if (err < ER_OK) {
		D(("taskspace_switch: SetTaskSpace %d\n", err));
		goto fin0;
	}

	/* block deviceΨ */
	mul = (q->datano >= 0 &&
	       (q->cmd.cmd == DC_READ || q->cmd.cmd == DC_WRITE)) ?
		SECTORSIZE : 1;

	/* ɥ쥹֤Υå */
	err = (q->cmd.cmd == DC_READ) ?
		CheckSpaceRW(q->memptr, q->datacnt * mul) :
		CheckSpaceR(q->memptr, q->datacnt * mul);

	if (err < ER_OK) {
		D(("taskspace_switch: CheckSpaceR(W) %d\n", err));
	}

 fin0:
	return err;
}

/* ɥ饤С */
LOCAL	void	vrd_task(UW calptn)
{
	ERR	err;
	RNO	rno;
	W	size;
	T_RTSK	rtsk;
	DevReq	q;
	DevRsp	r;
	DrvWork	*wk;

	/* μ */
	err = ref_tsk(&rtsk, TSK_SELF);
	if (err < ER_OK) {
		D(("vrd_task: ref_tsk %d\n", err));
		goto fin0;
	}
	wk = rtsk.exinf;

	/* ٥ȥ롼 */
	while (1) {
		/* ׵Ԥ */
		err = acp_por(&rno, (VP)&q, &size, wk->porid, calptn);
		if (err < ER_OK) {
			goto fin1;
		}

		/* ʥѥåȤ̵ */
		if (size != sizeof(q)) {
			D(("vrd_task: bad size %d\n", size));
			continue;
		}

		/* ֤ڤؤ */
		err = taskspace_switch(&q);
		if (err < ER_OK) {
			D(("vrd_task: taskspace_switch %d\n", err));
			/* 顼ɤƤӽФ֤ */
		}

		/* ѥѥåȤν׵μ¹ */
		r.devid     = q.devid;
		r.cmd       = q.cmd;
		r.datano    = q.datano;
		r.datacnt   = 0;
		r.error.err = (err < ER_OK) ? err : vrd_request(wk, &q, &r);

		/* ǥ֤ؤ */
		err = rpl_rdv(rno, (VP)&r, sizeof(r));
		if (err < ER_OK) {
			D(("vrd_task: rpl_rdv %d\n", err));
		}
	}

 fin1:
	del_por(wk->porid);
 fin0:
	exd_tsk();
}

/* ɥ饤еư */
EXPORT	ERR	vrd_start(DrvWork *wk)
{
	WERR	err;
	T_CTSK	ctsk;
	T_CPOR	cpor;
	DevDef	dd;

	/* ǥ֥ݡȺ */
	cpor.exinf   = (VP)CH4toW('v', 'r', 'd', 'a');
	cpor.poratr  = TA_NULL;
	cpor.maxcmsz = sizeof(DevReq);
	cpor.maxrmsz = sizeof(DevRsp);
	err = vcre_por(&cpor);
	if (err < ER_OK) {
		D(("vrd_start: vcre_por %d\n", err));
		goto fin0;
	}
	wk->porid = err;

	/*  */
	ctsk.exinf   = wk;
	ctsk.task    = vrd_task;
	ctsk.itskpri = VRDTASK_PRI;
	ctsk.stksz   = VRDTASK_STKSZ;
	ctsk.tskatr  = TA_HLNG | TA_RNG0;
	err = vcre_tsk(&ctsk);
	if (err < ER_OK) {
		D(("vrd_start: vcre_tsk %d\n", err));
		goto fin1;
	}
	wk->tskid = err;

	/* ư */
	err = sta_tsk(wk->tskid, D_NORM_PTN | D_ABORT_PTN);
	if (err < ER_OK) {
		D(("vrd_start: sta_tsk %d\n", err));
		goto fin2;
	}

	/* ǥХϿ */
	memset(&dd, 0, sizeof(dd));
	dd.attr.devinfo  = 0;
	dd.attr.devkind  = DK_DISK_RAM;
	dd.attr.reserved = 0;		/* ͽ(0) */
	dd.attr.openreq  = 0;		/* open/close򤽤𤷤ʤ */
	dd.attr.lockreq  = 0;		/* lock */
	dd.attr.diskinfo = 1;		/* diskinfo */
	dd.attr.chardev  = 0;		/* block device */
	dd.attr.nowait   = 0;		/* nowaitб */
	dd.attr.eject    = 0;		/* ejectб */
	dd.subunits      = 0;		/* subunit̵ */
	memcpy(dd.name, DrvName, sizeof(DrvName));
	dd.portid = wk->porid;

	wk->diskinfo.format    = DiskFmt_MEM;
	wk->diskinfo.protect   = False;
	wk->diskinfo.removable = False;
	wk->diskinfo.rsv       = 0;
	wk->diskinfo.blocksize = SECTORSIZE;
	wk->diskinfo.blockcont = BYTEtoSECTOR(wk->memsize);

	err = b_DefDevice(&dd, &wk->diskinfo);
	if (err < ER_OK) {
		D(("vrd_start: b_DefDevice %d\n", err));
		goto fin3;
	}
	wk->devid = err;

	/* ưλ */
	err = ER_OK;
	goto fin0;

 fin3:
	ter_tsk(wk->tskid);
 fin2:
	del_tsk(wk->tskid);
 fin1:
	del_por(wk->porid);
 fin0:
	return err;
}

/* ɥ饤нλ */
EXPORT	ERR	vrd_finish(DrvWork *wk)
{
	/* ǥ֥ݡȤκǼ */
	del_por(wk->porid);

	return ER_OK;
}
